// Rule.h
//--------------------------------------------------------------------

#import <objectbase/SwarmObject.h>
#import <random.h>
#import <collections.h>
#import "Treasury.h"
#import "Message.h"
#import "Dump.h"
#import "Trace.h"

//--------------------------------------------------------------------
@interface Rule: SwarmObject

{

   char    eyeCatcher[4];
   id      partnerList;
   Dump *  dump;
   double  strength,bid,eBid,specificity;
   int     length;
   char    condition[256];
   char    action[256];

}

//--------------------------------------------------------------------

-          createEnd;
- (void)   drop;

-          setCondition: (char *) aS;
-          setAction: (char *) aS;
-          setLength: (int) ll;
-          setStrength: (double) ss;
-          setDump: (Dump *) du;
- (char *) getCondition;
- (char *) getAction;
- (double) getStrength;
- (double) getEBid;

- (int)    matchMessage: (Messag *) me;
-          resetPartnerList;
-          modifyConditionTo: (char *) aS;
-          modifyActionTo:    (char *) aS;
-          bidWithRatio: (float) bR lBid1: (float) l1 lBid2: (float) l2
                 eLBid1: (float) e1 eLBid2: (float) e2
               bidSigma: (float) bS bidMu: (float) bM;
-          payTaxOf: (float) tR to: (Treasury *) tr;
- (char *) payAndFire;
-          cash: (double) rw;

-          print;
//--------------------------------------------------------------------
@end
